<?php
ini_set('memory_limit', '1024M');
ini_set('max_execution_time', '0');

/*
$memory_limit = ini_get('memory_limit');
$max_execution_time = ini_get('max_execution_time');
echo "<br>memory_limit: ".$memory_limit;
echo "<br>max_execution_time: ".$max_execution_time;
exit;
*/

global $wp_query;
$file_id = $wp_query->query_vars['file_id'];
 
$file_url_full = base64_decode($file_id);

$file_url_parts = explode('|',$file_url_full);

$product_id = $file_url_parts[0];
$file_url = $file_url_parts[1];

//Validate if file is ok to download. This will prevent to download private files from the server or external websites.
if(!dfd_is_valid_file_url($file_url)){
	echo "This file URL is not valid for direct free download.";
	exit;
}

//It is found that the product is set for direct download.
if(!dfd_is_virtual_free_download_product($product_id)){
	echo "This product is not available for direct free download.";
	exit;
}

dfd_update_download_count($product_id);

dfd_download_file($file_url,$product_id);

//echo "<br/>file_url:".$file_url." <br/>product_id:".$product_id;
//WC_Download_Handler::download($file_url, $product_id);
exit;



/**
 * Returns the size of a file without downloading it, or -1 if the file
 * size could not be determined.
 */
function retrieve_remote_file_size($url){
     $ch = curl_init($url);
     
     curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
     curl_setopt($ch, CURLOPT_RETURNTRANSFER, TRUE);
     curl_setopt($ch, CURLOPT_HEADER, TRUE);
     curl_setopt($ch, CURLOPT_NOBODY, TRUE);

     $data = curl_exec($ch);
     $size = curl_getinfo($ch, CURLINFO_CONTENT_LENGTH_DOWNLOAD);

     curl_close($ch);
     
     
     //$size = @filesize($url);
     
     echo $url.'<br/>';
     echo $size;
     exit;
     return $size;
}

/**
 * Get absolute path of the file url 
 */
function dfd_absolute_path($file_path) {

	$network_url = is_ssl() ? str_replace( 'https:', 'http:', network_admin_url() ) : network_admin_url();
	$upload_dir  = wp_upload_dir();
	
	// Try to replace network url
	$file_path   = str_replace( trailingslashit( $network_url ), ABSPATH, $file_path );
	
	// Now try to replace upload URL
	$file_path   = str_replace( $upload_dir['baseurl'], $upload_dir['basedir'], $file_path );
	
	// Remove Query String
	if ( strstr( $file_path, '?' ) ) {
		$file_path = current( explode( '?', $file_path ) );
	}
	$file_path  = realpath( $file_path );
	
	return $file_path;
}


/**
 * Downloads the url file
 * @param unknown $fullPath
 */
function dfd_download_file($file_url,$product_id){

	//Check if the $file_url is an external file
	$external_file = false;
	if (parse_url(get_option('home'), PHP_URL_HOST ) != parse_url($file_url, PHP_URL_HOST )) {
		$external_file = true;
	}
	
	// Redirect to the file.
	$file_download_method = apply_filters( 'woocommerce_file_download_method', get_option( 'woocommerce_file_download_method' ), $product_id );
	if ($file_download_method != "redirect" && !$external_file) {
		//Get absolute path
		$file_url = dfd_absolute_path($file_url);
	}
	
	//echo $file_url;
	//exit;
	
	// Must be fresh start
	if( headers_sent() )
		die('Headers Sent');

	// Required for some browsers
	if(ini_get('zlib.output_compression'))
		ini_set('zlib.output_compression', 'Off');
	

	// File Exists?
	if (isset($file_url)){
		// Parse Info / Get Extension
		$path_parts = pathinfo($file_url);
		$ext = strtolower($path_parts["extension"]);
		$basename_file = $path_parts['basename'];
		
		//If links contains dropbox extensión
		$ext = str_replace('?dl=1', '', $ext);
		$basename_file = str_replace('?dl=1', '', $basename_file);
		
		// Determine Content Type
		switch ($ext) {
			case "pdf": $ctype="application/pdf"; break;
			case "exe": $ctype="application/octet-stream"; break;
			case "zip": $ctype="application/zip"; break;
			case "doc": $ctype="application/msword"; break;
			case "docx": $ctype="application/msword"; break;
			case "xls": $ctype="application/vnd.ms-excel"; break;
			case "ppt": $ctype="application/vnd.ms-powerpoint"; break;
			case "gif": $ctype="image/gif"; break;
			case "png": $ctype="image/png"; break;
			case "jpeg":
			case "jpg": $ctype="image/jpg"; break;
			default: $ctype="application/force-download";
		}
		header("Pragma: public"); // required
		header("Expires: 0");
		header("X-Robots-Tag: noindex, nofollow", true);
		header("Cache-Control: must-revalidate, post-check=0, pre-check=0");
		header("Cache-Control: private",false); // required for certain browsers
		header("Content-Type: $ctype");
		header("Content-Disposition: attachment; filename=\"".$basename_file."\";" );
		header("Content-Transfer-Encoding: Binary");
		//$fsize = retrieve_remote_file_size($file_url);
		if ($fsize = @filesize($file_url)) {
			header( "Content-Length: ".$fsize);
		}
		ob_clean();
		flush();

		readfile($file_url);

	} else
		die('File Not Found');

}

//Update download counter for this product
function dfd_update_download_count($product_id) {
	$count = get_post_meta($product_id, '_dfd_download_count', true);
	if (empty($count)) { $count = 0; }
	$count++;
	update_post_meta($product_id, '_dfd_download_count', $count);
}

//Validate if file is ok to download. This will prevent to download private files from the server or external websites.
function dfd_is_valid_file_url($file_url) {

	// File Exists?
	if (!isset($file_url)){
		return false;
	}else{
			
		// Parse Info / Get Extension
		$path_parts = pathinfo($file_url);
		//print_r($path_parts);
		
		$dirname = strtolower($path_parts["dirname"]);
		$ext = strtolower($path_parts["extension"]);
		$basename_file = $path_parts['basename'];
	
		//If links contains dropbox extensión
		$ext = str_replace('?dl=1', '', $ext);
		$basename_file = str_replace('?dl=1', '', $basename_file);
		
		//Prevent web downloading
		if (in_array($ext, array('es', 'com', 'net', 'co.uk')) || in_array($dirname, array('http:', 'https:'))) { 
			return false;
		}
		
		//Prevent critical security file downloading
		if (in_array($dirname, array('/etc')) || in_array($basename_file, array('passwd','shadow')) ) {
			return false;
		}
		
		return true;
		
	}
}

?>